create or replace PROCEDURE MAPAAPUR_FRETE
   (P_CDFILIAL     IN FILIAL.CDFILIAL%TYPE,
    P_IDTPIJURTRAN IN TRANSPORT.IDTPIJURTRAN%TYPE,
    P_NRINSJURTRAN IN TRANSPORT.NRINSJURTRAN%TYPE,
    P_DTINICIAL    IN NOTAFISCAL.DTENTRSAID%TYPE,
    P_DTFINAL      IN NOTAFISCAL.DTENTRSAID%TYPE,
    P_NRMAPAAPU    IN MAPAFRETEEXP.NRSEQMAPAPU%TYPE,
    P_EXCLUIEXPED  IN VARCHAR2 DEFAULT 'S',
    P_NREXPEDICAO  IN EXPEDICAO.NREXPEDICAO%TYPE DEFAULT '')
AS
   V_PROXLANBOLPAG VARCHAR2(20);
   V_VRTAXACOLETA    FLOAT;
   V_IDTIPOFRETE     VARCHAR2(1); -- FIXO OU VARIVEL
   V_IDORIGFRETE     VARCHAR2(1); -- Se o frete busca do cadastro de frete por filial, frete por cliente, veculo, transportadora...
   V_DTEXPEDICAO     DATE;
   V_VRFIXOFIL       FLOAT;
   V_VRFIXOCLI       FLOAT;
   V_VRFIXOVIATU     FLOAT;
   V_VRPESOKG        FLOAT;
   V_VRKG            FLOAT;
   V_VRKGTOTAL       FLOAT;
   V_VRKMINICIAL     FLOAT;
   V_VRKMFINAL       FLOAT;
   V_VRKMRODADO      FLOAT;
   V_VRKM            FLOAT;
   V_VRKMTOTAL       FLOAT;
   V_VRPERCADVALOREM FLOAT;
   V_VRADVALOREM     FLOAT;
   V_VRTXCOLETA      FLOAT;
   V_VRPERCICMS      FLOAT;
   V_VRICMS          FLOAT;
   V_VRFRETE         FLOAT;
   V_VRFRETEPADR     FLOAT;


   V_QTNOTA          FLOAT;
   V_TXCOLETA_NF     FLOAT;
   V_VRTARAVEIC      FLOAT;
   V_VRKMMEDLITRO    FLOAT;
   V_VRKMRODAVIAT    FLOAT;
   V_VRTOTALFRETE    FLOAT;
   V_DTENTRSAID      DATE;

BEGIN
   /*
   Se for inserido uma expedio manualmente o P_EXCLUIEXPED ser N e o reclculo ser
   com base na expedio includa. Em apurao normal, todas as expedies
   j apuradas so deletadas e includas novamente recalculando os valores e com base no perodo
   filtrado.
   */

   IF (P_EXCLUIEXPED = 'S') THEN
      -- DELETA AS EXPEDIES DO PERIODO
      DELETE FROM MAPAFRETEEXP
        WHERE CDFILIAL     = P_CDFILIAL
          AND NRSEQMAPAPU  = P_NRMAPAAPU
          AND IDTPIJURTRAN = P_IDTPIJURTRAN
          AND NRINSJURTRAN = P_NRINSJURTRAN;

      DELETE FROM MAPAFRETENF
        WHERE CDFILIAL     = P_CDFILIAL
          AND NRSEQMAPAPU  = P_NRMAPAAPU
          AND IDTPIJURTRAN = P_IDTPIJURTRAN
          AND NRINSJURTRAN = P_NRINSJURTRAN;
   ELSE
      DELETE FROM MAPAFRETENF
        WHERE IDTPIJURTRAN = P_IDTPIJURTRAN
          AND NRINSJURTRAN = P_NRINSJURTRAN
          AND CDFILIAL     = P_CDFILIAL
          AND NREXPEDICAO  = P_NREXPEDICAO
          AND NRSEQMAPAPU  = P_NRMAPAAPU;
   END IF;

   V_VRTOTALFRETE := NULL;

   FOR C_EXP IN (SELECT DISTINCT NF.CDFILIAL, NF.NREXPEDICAO
                     FROM NOTAFISCAL NF
                    WHERE NF.CDFILIAL     = P_CDFILIAL
                      AND NF.IDTPIJURTRAN = P_IDTPIJURTRAN
                      AND NF.NRINSJURTRAN = P_NRINSJURTRAN
                      AND NF.DTENTRSAID BETWEEN P_DTINICIAL AND P_DTFINAL
                      AND NF.IDENTRSAIDOP = 'S'
                      AND NF.IDSISTEMA    = 'EXP'
                      AND P_EXCLUIEXPED   = 'S'

                 UNION ALL

                 SELECT DISTINCT NF.CDFILIAL, NF.NREXPEDICAO
                     FROM NOTAFISCAL NF
                    WHERE NF.CDFILIAL     = P_CDFILIAL
                      AND NF.IDTPIJURTRAN = P_IDTPIJURTRAN
                      AND NF.NRINSJURTRAN = P_NRINSJURTRAN
                      AND NF.IDENTRSAIDOP = 'S'
                      AND NF.IDSISTEMA    = 'EXP'
                      AND NF.NREXPEDICAO  = P_NREXPEDICAO
                      AND P_EXCLUIEXPED   = 'N'
                   ORDER BY 1,2
                 ) LOOP

         IF (P_EXCLUIEXPED = 'S') THEN
            -- Busca a taxa de coleta padro da transportadora
            SELECT NVL(TXCOLETAPADR, 0)
              INTO V_VRTAXACOLETA
              FROM TRANSPORT
             WHERE IDTPIJURTRAN   = P_IDTPIJURTRAN
               AND NRINSJURTRAN   = P_NRINSJURTRAN;
         ELSE
            -- Busca a taxa de coleta informada/alterada no mapa
            SELECT NVL(VRTXCOLETA,0)
              INTO V_VRTAXACOLETA
              FROM MAPAFRETEEXP
             WHERE IDTPIJURTRAN = P_IDTPIJURTRAN
               AND NRINSJURTRAN = P_NRINSJURTRAN
               AND CDFILIAL     = P_CDFILIAL
               AND NREXPEDICAO  = P_NREXPEDICAO
               AND NRSEQMAPAPU  = P_NRMAPAAPU;
         END IF;

         SELECT MAX(DTENTRSAID)
           INTO V_DTENTRSAID
           FROM NOTAFISCAL
          WHERE CDFILIAL     = P_CDFILIAL
            AND NREXPEDICAO  = C_EXP.NREXPEDICAO;

         IF (P_EXCLUIEXPED = 'S') THEN
            -- Insere a(s) taxa(s) relacionadas a Expedio
            INSERT INTO MAPAFRETEEXP
               (CDFILIAL, NREXPEDICAO, IDTPIJURTRAN, NRINSJURTRAN, NRSEQMAPAPU, VRTXCOLETA,
                DTEXPEDICAO)
            VALUES
               (P_CDFILIAL, C_EXP.NREXPEDICAO, P_IDTPIJURTRAN, P_NRINSJURTRAN, P_NRMAPAAPU, V_VRTAXACOLETA,
                V_DTENTRSAID);
         END IF;

         SELECT COUNT(*)
           INTO V_QTNOTA
           FROM NOTAFISCAL
          WHERE CDFILIAL    = P_CDFILIAL
            AND NREXPEDICAO = C_EXP.NREXPEDICAO;

          V_TXCOLETA_NF := V_VRTAXACOLETA / V_QTNOTA;

         -- Busca as NFs ligadas a Expedio
         FOR C_NOTAS IN (SELECT NF.CDFILIAL, NF.CDFILIEMIT, NF.CDFILIRECE, NF.NRLANCTONF, NF.DTENTRSAID, NF.NRNOTAFISC,
                                NF.NRPLACAVEIC, NF.CDROTATRANS, NF.IDTPIJURTRAN, NF.NRINSJURTRAN, NF.NREXPEDICAO,
                                NF.VRPBRUTOVOLU, NF.VRPLIQUVOLU, NVL(NF.IDORIGDESTNF, 'C') IDORIGDESTNF ,
                                NF.VRNOTAFISC, NF.CDVIATURA, NF.CDCLIENTE
                     FROM NOTAFISCAL NF, VIATURA V, ROTATRANS R
                    WHERE NF.CDFILIAL     = P_CDFILIAL
                      AND NF.NREXPEDICAO  = C_EXP.NREXPEDICAO
                      AND NF.NRPLACAVEIC  = V.NRPLACA(+)
                      AND NF.CDVIATURA    = V.CDVIATURA(+)
                      AND NF.CDROTATRANS  = R.CDROTATRANS(+)
                      AND NF.IDTPIJURTRAN = P_IDTPIJURTRAN
                      AND NF.NRINSJURTRAN = P_NRINSJURTRAN
                    ORDER BY 1, 2) LOOP

            V_VRPESOKG        := 0;
            V_VRKG            := 0;
            V_VRKGTOTAL       := 0;
            V_VRKMINICIAL     := 0;
            V_VRKMFINAL       := 0;
            V_VRKMRODADO      := 0;
            V_VRKM            := 0;
            V_VRKMTOTAL       := 0;
            V_VRPERCADVALOREM := 0;
            V_VRADVALOREM     := 0;
            V_VRTXCOLETA      := 0;
            V_VRPERCICMS      := 0;
            V_VRICMS          := 0;
            V_VRFRETE         := 0;
            V_IDORIGFRETE     := NULL;

            V_VRTARAVEIC      := 0;
            V_VRKMMEDLITRO    := 0;
            V_VRKMRODAVIAT    := 0;

            V_VRFIXOCLI       := 0;
            V_VRFIXOFIL       := 0;
            V_VRFIXOVIATU     := 0;
            V_VRFRETEPADR     := 0;

            -- Se a NF for de Filial
            IF (C_NOTAS.IDORIGDESTNF = 'L') THEN
               BEGIN
                  SELECT NVL(VRFIXOFIL, 0), 'F'
                    INTO V_VRFIXOFIL, V_IDORIGFRETE
                    FROM FRETEFILIAL
                   WHERE CDFILIAL     = C_NOTAS.CDFILIRECE
                     AND IDTPIJURTRAN = C_NOTAS.IDTPIJURTRAN
                     AND NRINSJURTRAN = C_NOTAS.NRINSJURTRAN;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_IDORIGFRETE := NULL;
               END;

               -- Se existir cadastro na tela de Frete por Filial
               IF NOT (V_IDORIGFRETE IS NULL) THEN

                  -- Frete fixo ou varivel
                  IF (V_VRFIXOFIL > 0) THEN
                     V_IDTIPOFRETE :=  'F';        -- FRETE FIXO
                  ELSE
                     V_IDTIPOFRETE := 'V';         -- FRETE VARIVEL
                  END IF;

                  IF (V_IDTIPOFRETE = 'F') then
                     V_VRFRETE := V_VRFIXOFIL + V_TXCOLETA_NF;
                  ELSE

                     SELECT NVL(FR.VRKILOFIL, 0), NVL(FR.VRKMFIL, 0), NVL(FR.VRDISKMFIL, 0), NVL(FR.TXADVALOREMFIL, 0),  NVL(FR.VRTXICMSFIL, 0)
                       INTO V_VRKG,       V_VRKM,     V_VRKMRODADO,  V_VRPERCADVALOREM, V_VRPERCICMS
                       FROM FRETEFILIAL FR, FILIAL F
                      WHERE FR.CDFILIAL     = F.CDFILIAL
                        AND FR.IDTPIJURTRAN = P_IDTPIJURTRAN
                        AND FR.NRINSJURTRAN = P_NRINSJURTRAN
                        AND FR.CDFILIAL     = C_NOTAS.CDFILIRECE;

                     -- (PESO + KM + ADVALOREM + TAXA DE COLETA)
                     V_VRICMS := (C_NOTAS.VRPBRUTOVOLU * V_VRKG) + (V_VRKMRODADO*V_VRKM) + ((C_NOTAS.VRNOTAFISC * V_VRPERCADVALOREM) / 100) + (V_TXCOLETA_NF);
                     V_VRICMS := ((V_VRICMS * V_VRPERCICMS) / 100);

                     -- (PESO + KM + ADVALOREM + TAXA DE COLETA + ICMS)
                     V_VRFRETE :=  (C_NOTAS.VRPBRUTOVOLU * V_VRKG) + (V_VRKMRODADO*V_VRKM) + ((C_NOTAS.VRNOTAFISC * V_VRPERCADVALOREM) / 100) + (V_TXCOLETA_NF) + V_VRICMS;

                  END IF;
               END IF;
            ELSE
               -- SE A NOTA FOR DE CLIENTE
               IF (C_NOTAS.IDORIGDESTNF = 'C') THEN
                  BEGIN
                     SELECT NVL(VRFIXOCLI, 0), 'C'
                       INTO V_VRFIXOCLI, V_IDORIGFRETE
                       FROM FRETECLIENTE
                      WHERE CDCLIENTE    = C_NOTAS.CDCLIENTE
                        AND IDTPIJURTRAN = C_NOTAS.IDTPIJURTRAN
                        AND NRINSJURTRAN = C_NOTAS.NRINSJURTRAN;
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_IDORIGFRETE := NULL;
                  END;

                  -- Se existir cadastro na tela de Frete por cliente
                  IF NOT (V_IDORIGFRETE IS NULL) THEN

                     -- Frete fixo ou varivel
                     IF (V_VRFIXOCLI > 0) THEN
                        V_IDTIPOFRETE :=  'F';        -- FRETE FIXO
                     ELSE
                        V_IDTIPOFRETE := 'V';         -- FRETE VARIVEL
                     END IF;

                     IF (V_IDTIPOFRETE = 'F') then
                        V_VRFRETE := V_VRFIXOCLI + V_TXCOLETA_NF;
                     ELSE

                        SELECT NVL(FC.VRKILOCLI, 0), NVL(FC.VRKMCLI, 0), NVL(FC.VRDISKMCLI, 0), NVL(FC.TXADVALOREMCLI, 0),  NVL(FC.VRTXICMSCLI, 0)
                          INTO V_VRKG,       V_VRKM,     V_VRKMRODADO,  V_VRPERCADVALOREM, V_VRPERCICMS
                          FROM FRETECLIENTE FC, CLIENTE C
                         WHERE FC.CDCLIENTE    = C.CDCLIENTE
                           AND FC.IDTPIJURTRAN = P_IDTPIJURTRAN
                           AND FC.NRINSJURTRAN = P_NRINSJURTRAN
                           AND FC.CDCLIENTE    = C_NOTAS.CDCLIENTE;

                        -- (PESO + KM + ADVALOREM + TAXA DE COLETA)
                        V_VRICMS := (C_NOTAS.VRPBRUTOVOLU * V_VRKG) + (V_VRKMRODADO*V_VRKM) + ((C_NOTAS.VRNOTAFISC * V_VRPERCADVALOREM) / 100) + (V_TXCOLETA_NF);
                        V_VRICMS := ((V_VRICMS * V_VRPERCICMS) / 100);

                        -- (PESO + KM + ADVALOREM + TAXA DE COLETA + ICMS)
                        V_VRFRETE :=  (C_NOTAS.VRPBRUTOVOLU * V_VRKG) + (V_VRKMRODADO*V_VRKM) + ((C_NOTAS.VRNOTAFISC * V_VRPERCADVALOREM) / 100) + (V_TXCOLETA_NF) + V_VRICMS;

                     END IF;
                  END IF;
               END IF;
            END IF;

            -- SE NO ACHAR FRETE POR FILIAL/CLIENTE, BUSCA O FRETE PADRO DA TRANSPORTADORA
            IF (V_IDORIGFRETE IS NULL) THEN
               BEGIN
                  SELECT NVL(VRFRETEPADR,0), 'T'
                    INTO V_VRFRETEPADR, V_IDORIGFRETE
                    FROM TRANSPORT
                   WHERE IDTPIJURTRAN = P_IDTPIJURTRAN
                     AND NRINSJURTRAN = P_NRINSJURTRAN
                     AND NVL(VRFRETEPADR,0)  > 0;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_IDORIGFRETE := NULL;
               END;

               V_VRFRETE := V_VRFRETEPADR + V_TXCOLETA_NF;

               -- SE NO ACHAR FRETE PADRO DA TRANSPORTADORA, BUSCA O FRETE PADRAO DA FILIAL DE EXPEDIO
               IF (V_IDORIGFRETE IS NULL) THEN
                  BEGIN
                     SELECT NVL(VRFRETEPADRAO,0), 'E'
                       INTO V_VRFRETEPADR, V_IDORIGFRETE
                       FROM PAREXPEDICAO
                      WHERE CDFILIAL = P_CDFILIAL
                        AND NVL(VRFRETEPADRAO,0)  > 0;
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_IDORIGFRETE := NULL;
                  END;

                  V_VRFRETE := V_VRFRETEPADR + V_TXCOLETA_NF;

               -- SE NO ACHAR FRETE PADRO DA FILIAL DE EXPEDIO, VERIFICA O FRETE POR VECULO
               ELSE
                  IF (V_IDORIGFRETE IS NULL) THEN
                     BEGIN
                        SELECT NVL(VRFRETEVIATU, 0), NVL(QTTARAVIAT, 0), NVL(VRKMMEDLITRO, 0), NVL(VRKMRODAVIAT, 0), 'V'
                          INTO V_VRFIXOVIATU,    V_VRTARAVEIC, V_VRKMMEDLITRO, V_VRKMRODAVIAT, V_IDORIGFRETE
                          FROM VIATURA
                         WHERE CDVIATURA = C_NOTAS.CDVIATURA;
                     EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_IDORIGFRETE := NULL;
                     END;

                     -- Frete fixo ou varivel
                     IF (V_VRFIXOVIATU > 0) THEN
                        V_IDTIPOFRETE :=  'F';        -- FRETE FIXO
                     ELSE
                        V_IDTIPOFRETE := 'V';         -- FRETE VARIVEL
                     END IF;

                     IF (V_IDTIPOFRETE = 'V') THEN
                        V_VRFRETE :=  (V_VRTARAVEIC * C_NOTAS.VRPBRUTOVOLU) + (V_VRKMMEDLITRO * V_VRKMRODAVIAT);
                     ELSE
                        V_VRFRETE := V_VRFIXOVIATU + V_TXCOLETA_NF;
                     END IF;
                  END IF;
               END IF;

            END IF;

            INSERT INTO MAPAFRETENF
               (CDFILIAL, NREXPEDICAO, IDTPIJURTRAN, NRINSJURTRAN,  NRLANCTONF,
                NRSEQMAPAPU, VRKG, VRKGTOTAL, VRKMINICIAL, VRKMFINAL,
                VRKMRODADO, VRKM, VRKMTOTAL, VRPERCADVALOREM, VRADVALOREM, VRTXCOLETA,
                VRPERCICMS, VRICMS, VRFRETE, VRPESOBRUTO, VRPESOLIQ)
            VALUES
               (P_CDFILIAL, C_NOTAS.NREXPEDICAO, P_IDTPIJURTRAN, P_NRINSJURTRAN,  C_NOTAS.NRLANCTONF,
                P_NRMAPAAPU, V_VRKG, (C_NOTAS.VRPBRUTOVOLU * V_VRKG), 0, 0,
                V_VRKMRODADO, V_VRKM, (V_VRKMRODADO*V_VRKM), V_VRPERCADVALOREM, ((C_NOTAS.VRNOTAFISC * V_VRPERCADVALOREM) / 100), V_TXCOLETA_NF,
                V_VRPERCICMS, V_VRICMS, V_VRFRETE, C_NOTAS.VRPBRUTOVOLU, C_NOTAS.VRPLIQUVOLU);
         END LOOP;
   END LOOP;

   -- Atualiza o valor total do frete para o mapa
   SELECT NVL(SUM(VRFRETE),0) VRFRETEAPUR
      INTO V_VRTOTALFRETE
      FROM MAPAFRETENF
    WHERE CDFILIAL     = P_CDFILIAL
      AND IDTPIJURTRAN = P_IDTPIJURTRAN
      AND NRINSJURTRAN = P_NRINSJURTRAN
      AND NRSEQMAPAPU  = P_NRMAPAAPU;

   UPDATE MAPAAPUFRETE
     SET VRTOTALFRETE  = V_VRTOTALFRETE
    WHERE CDFILIAL     = P_CDFILIAL
      AND IDTPIJURTRAN = P_IDTPIJURTRAN
      AND NRINSJURTRAN = P_NRINSJURTRAN
      AND NRSEQMAPAPU  = P_NRMAPAAPU;
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('MAPAAPUR_FRETE','6.05.xxx'); END;
/
